"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var macro_1 = __importStar(require("styled-components/macro"));
var Mobile_1 = require("../media-query/Mobile");
var index_1 = require("../index");
var NUMBER_OF_COLUMNS = 12;
var getBreakPoint = function (sm, md, lg, xl) {
    if (sm)
        return Mobile_1.__MEDIA_QUERY_BREAK_POINT.SMALL;
    if (md)
        return Mobile_1.__MEDIA_QUERY_BREAK_POINT.MEDIUM;
    if (lg)
        return Mobile_1.__MEDIA_QUERY_BREAK_POINT.LARGE;
    if (xl)
        return Mobile_1.__MEDIA_QUERY_BREAK_POINT.EXTRA_LARGE;
    return null;
};
var getDimension = function (n) {
    return (n / NUMBER_OF_COLUMNS) * 100;
};
var getFlex = function (t) {
    return typeof t === "number" ? getDimension(t) + "%" : "auto";
};
var getMaxWidth = function (t) {
    return typeof t === "number" ? getDimension(t) + "%" : "100%";
};
var getWidth = function (t) { return (typeof t === "number" ? "100%" : "auto"); };
var getMediaQuery = function (breakPoint, t) {
    if (!breakPoint)
        return null;
    if (!t)
        return null;
    if (typeof t === "boolean") {
        return Mobile_1.makeQuery(breakPoint)(SimpleCol);
    }
    return Mobile_1.makeQuery(breakPoint)("\n      flex: 0 0 " + getFlex(t) + "; \n      max-width: " + getMaxWidth(t) + ";\n      width: " + getWidth(t) + ";  \n  ");
};
var computeOffset = function (sm, md, lg, xl, offset) {
    var breakPoint = getBreakPoint(sm, md, lg, xl);
    if (!breakPoint)
        return "";
    if (!sm && !md && !lg && !xl)
        return "";
    if (!offset)
        return "";
    return Mobile_1.makeQuery(breakPoint)("margin-left: " + getDimension(offset) + "%");
};
var getDefaultColCSS = function (col) { return macro_1.css(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  flex: 0 0 ", "%;\n  max-width: ", "%;\n"], ["\n  flex: 0 0 ", "%;\n  max-width: ", "%;\n"])), getDimension(col), getDimension(col)); };
var ColRoot = macro_1.css(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  position: relative;\n  padding: 0 ", "px;\n  width: 100%;\n"], ["\n  position: relative;\n  padding: 0 ", "px;\n  width: 100%;\n"])), index_1.GUTTER);
var SimpleCol = macro_1.css(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  flex-basis: 0;\n  flex-grow: 1;\n  min-width: 0;\n  max-width: 100%;\n"], ["\n  flex-basis: 0;\n  flex-grow: 1;\n  min-width: 0;\n  max-width: 100%;\n"])));
exports.Col = macro_1.default.div(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", "\n  ", ";\n"], ["\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ", ";\n  ",
    ";\n  ",
    "\n  ", ";\n"])), function (_a) {
    var sm = _a.sm;
    return getMediaQuery(Mobile_1.__MEDIA_QUERY_BREAK_POINT.SMALL, sm);
}, function (_a) {
    var md = _a.md;
    return getMediaQuery(Mobile_1.__MEDIA_QUERY_BREAK_POINT.MEDIUM, md);
}, function (_a) {
    var lg = _a.lg;
    return getMediaQuery(Mobile_1.__MEDIA_QUERY_BREAK_POINT.LARGE, lg);
}, function (_a) {
    var xl = _a.xl;
    return getMediaQuery(Mobile_1.__MEDIA_QUERY_BREAK_POINT.EXTRA_LARGE, xl);
}, function (_a) {
    var sm = _a.sm, md = _a.md, lg = _a.lg, xl = _a.xl;
    return !sm && !md && !lg && !xl && SimpleCol;
}, function (_a) {
    var sm = _a.sm, md = _a.md, lg = _a.lg, xl = _a.xl, offset = _a.offset;
    return computeOffset(sm, md, lg, xl, offset);
}, function (_a) {
    var xs = _a.xs;
    return xs
        ? typeof xs === "number"
            ? getDefaultColCSS(xs)
            : SimpleCol
        : "";
}, function (_a) {
    var order = _a.order;
    return order &&
        "order: " + order + ";\n  ";
}, ColRoot);
var templateObject_1, templateObject_2, templateObject_3, templateObject_4;
